(function (exports) {
'use strict';

var types = exports.DNS_TYPES = {
  A: 			0x01	//   1
, NS: 		0x02  //   2
, CNAME: 	0x05  //   5
, SOA: 		0x06  //   6
, PTR: 		0x0c  //  12
, MX: 		0x0f  //  15
, TXT: 		0x10  //  16
, AAAA: 	0x1c  //  28
, SRV: 		0x21  //  33
, OPT: 		0x29  //  41
, ANY: 		0xff  // 255
};

// and in reverse
Object.keys(types).forEach(function (key) {
  types[types[key]] = key;
});

}('undefined' !== typeof window ? window : exports));
